#!/bin/bash
#	Netdisco script written by:
# 
#	Adnan Tukic - tukic.adnan@gmail.com
#
#	Marcus Persson - knasingen@gmail.com

sed1="sed -i 's/qw(booleans array_refs hash_refs array_refs_mult hash_refs_mult)/(qw(booleans array_refs hash_refs array_refs_mult hash_refs_mult))/g' /usr/share/perl5/netdisco.pm"
sed2="sed -i '570s/.*/%  for my "'$f'" (qw(fw hw sw)) {/' /usr/share/netdisco/html/device.html"
sed3="sed -i '88s/.*/local	netdisco	netdisco			trust/' /etc/postgresql/9.1/main/pg_hba.conf"
sed4="sed -i '8s/.*/#/' /etc/netdisco/netdisco_apache2.conf"
sed5="sed -i '9s/.*/#/' /etc/netdisco/netdisco_apache2.conf"
sed6="sed -i '246s/.*/ServerName localhost/' /etc/apache2/apache2.conf"
sed7="sed -i '247s@.*@Include /etc/netdisco/netdisco_apache2.conf@' /etc/apache2/apache2.conf"
sed8="sed -i '248s@.*@Include /etc/netdisco/netdisco_apache2_dir.conf@' /etc/apache2/apache2.conf"


cpan="perl -MCPAN -e 'install CPAN'"
digest="perl -MCPAN -e 'install Digest::MD5'"
bundle="perl -MCPAN -e 'install Bundle::DBI'"
apachedbi="perl -MCPAN -e 'install Apache::DBI'"
dbdpg="perl -MCPAN -e 'install DBD::Pg'"
dbfile="perl -MCPAN -e 'install DB_File'"
apachesession="perl -MCPAN -e 'install Apache::Session'"
htmlentities="perl -MCPAN -e 'install HTML::Entities'"
htmlmason="perl -MCPAN -e 'install HTML::Mason'"
masonx="perl -MCPAN -e 'force install MasonX::Request::WithApacheSession'"
graph="perl -MCPAN -e 'install Graph'"
graphviz="perl -MCPAN -e 'install GraphViz'"
zlib="perl -MCPAN -e 'install Compress::Zlib'"
forkmanager="perl -MCPAN -e 'install Parallel::ForkManager'"
nbname="perl -MCPAN -e 'install Net::NBName'"
ldap="perl -MCPAN -e 'install Net::LDAP'"
ssleay="perl -MCPAN -e 'install Net::SSLeay'"
ssl="perl -MCPAN -e 'install IO::Socket::SSL'"
snmpinfo="perl -MCPAN -e 'force install SNMP::Info'"
apache2request="perl -MCPAN -e 'install Apache2::Request'"


if [ "$(id -u)" != "0" ]; then
	echo ""
	echo "Must be SUDO/ROOT to run this Netdisco Installer!" 1>&2
	echo ""
	exit 1
fi
eval clear
echo ""
echo -e "############## Made by Adnan Tukic & Marcus Persson - 2013 ##############" 
echo ""
eval tput sgr0
echo "This installation of Netdisco is adapted for Ubuntu/Debian systems!"
echo "We are not held responsible if you choose to run this on any other machine than Ubuntu/Debian."
echo "For more information go to http://netdisco.org" 
echo ""
echo -e "\E[31mIf you have never run CPAN(Perl installer) then it will autoupdate it's servers, just press enter for it to do it's thing."
eval tput sgr0
echo ""
echo -e "\E[33mWould you like to start the installation of Netdisco?(y/n)"
eval tput sgr0 
read y 


if [ $y = "y" ]; then
	echo ""
	echo -e "\E[33mSystem Is Running Update..."
	echo ""
	sleep 5
	eval tput sgr0

	eval apt-get update 
	eval apt-get upgrade -y

	echo ""
	echo -e "\E[33mRetrieving/Installing Netdisco Components..."
	echo ""
	sleep 5
	eval tput sgr0

	eval apt-get install postgresql-9.1 postgresql-server-dev-9.1 apache2 libperl-dev graphviz libnet-snmp-perl libapache2-mod-perl2 libapache-session-wrapper-perl libhtml-mason-perl libdbd-pg-perl libgraphviz-perl perl-modules libapache2-request-perl libnet-nbname-perl libsnmp-info-perl libapache-dbi-perl libmasonx-request-withapachesession-perl libparallel-forkmanager-perl libgraph-perl vim make build-essential libdb5.1-dev netdisco-common netdisco-frontend netdisco-backend netdisco-mibs-installer -y

	echo ""
	echo -e "\E[33mLoading Apache2 Modules & Restarting..."
	echo ""
	sleep 5
	eval tput sgr0
	
	eval $sed6
	eval a2enmod perl
	eval a2enmod apreq
	eval service apache2 restart

	echo ""
	echo -e "\E[33mConfiguring PostgreSQL..."
	echo ""
	sleep 5
	eval tput sgr0

	eval cp /etc/postgresql/9.1/main/pg_hba.conf /etc/postgresql/9.1/main/pg_hba.conf.orig

	eval $sed3 

	eval service postgresql restart

	echo ""
	echo -e "\E[33mConfiguring Netdisco..."
	echo ""
	sleep 5
	eval tput sgr0
	
	eval gunzip /usr/share/doc/netdisco-common/contrib/netdisco.conf.example.gz
	eval cp /usr/share/doc/netdisco-common/contrib/netdisco.conf.example /etc/netdisco/netdisco.conf
	eval sed -i "s/dbpassword/netdisco/g" /etc/netdisco/netdisco.conf
	eval cp -r /usr/share/doc/netdisco-backend/sql/ /usr/lib/netdisco/
	eval sed -i "s/PASSWORDHERE/netdisco/g" /etc/netdisco/netdisco_apache2.conf

	eval $sed4
	eval $sed5
	eval $sed7
	eval $sed8

	echo ""
	echo -e "\E[33mInstalling Perl Modules..."
	echo ""
	sleep 5
	eval tput sgr0

	eval $cpan
	eval $digest
	eval $bundle
	eval $apachedbi
	eval $dbdpg
	eval $dbfile
	eval $apachesession
	eval $htmlentities
	eval $htmlmason
	eval $masonx
	eval $graph
	eval $graphviz
	eval $zlib
	eval $forkmanager
	eval $nbname
	eval $ldap
	eval $ssleay
	eval $ssl
	eval $snmpinfo
	eval $apache2request
	
	echo ""
	echo -e "\E[33mCreating Netdisco Database..."
	echo ""
	sleep 5
	eval tput sgr0

	eval /usr/bin/npg --init  

	echo ""
	echo -e "\E[33mSetting Netdisco Rights..."
	echo ""
	sleep 5
	eval tput sgr0

	eval chown -R netdisco:netdisco /usr/share/netdisco
	eval chown -R www-data:www-data /usr/share/netdisco/html
	eval chown -R www-data:www-data /var/lib/netdisco/mason

	echo ""
	echo -e "\E[33mNetdisco SVG Settings... "
	echo ""
	sleep 5
	eval tput sgr0

	eval cd /usr/share/netdisco/html/
	eval wget http://downloads.sourceforge.net/project/netdisco/netdisco/1.0/netdisco-1.0.tar.gz
	eval tar -zxvf netdisco-1.0.tar.gz >/dev/null 2>&1
	eval cp -r /usr/share/netdisco/html/netdisco-1.0/html/svg/ /usr/share/netdisco/html/
	eval rm -r netdisco-1.0.tar.gz netdisco-1.0

	echo ""
	echo -e "\E[33mDownloading Netdisco MIBS..."
	echo ""
	sleep 5
	eval tput sgr0

	eval cd /usr/share/netdisco/mibs/
	eval wget http://downloads.sourceforge.net/project/netdisco/netdisco-mibs/latest-snapshot/netdisco-mibs-snapshot.tar.gz
	eval tar -zxvf netdisco-mibs-snapshot.tar.gz >/dev/null 2>&1
	eval cp -r /usr/share/netdisco/mibs/netdisco-mibs/* /usr/share/netdisco/mibs/
	eval rm -r netdisco-mibs netdisco-mibs-snapshot.tar.gz

	eval sed -i "s/local/share/g" /usr/share/netdisco/mibs/snmp.conf
	eval cp /usr/share/netdisco/mibs/snmp.conf /etc/snmp/

	echo ""
	echo -e "\E[33mDownloading & Installing NetSNMP..."
	echo ""
	sleep 5
	eval tput sgr0


	eval wget http://downloads.sourceforge.net/project/net-snmp/net-snmp/5.7.2/net-snmp-5.7.2.tar.gz

	eval tar -zxvf net-snmp-5.7.2.tar.gz >/dev/null 
	eval cd /usr/share/netdisco/mibs/net-snmp-5.7.2
	eval ./configure --with-perl-modules --enable-shared
	eval make 
	eval make install 
	eval cd /perl
	eval perl Makefile.PL 
	eval make 
	eval make install 

	eval cd /usr/share/netdisco/mibs/
	eval rm -r net-snmp-5.7.2.tar.gz net-snmp-5.7.2

	echo ""	
	echo -e "\E[33mConfiguring Specific Netdisco Files For New Perl5.14..."
	echo ""
	sleep 5
	eval tput sgr0

	eval $sed1
	eval $sed2

	echo ""
	echo -e "\E[33mCreating Netdisco User..."
	echo ""
	sleep 5
	eval tput sgr0

	eval /usr/bin/netdisco -u admin admin yes yes admin >/dev/null 2>&1
	
	echo ""
	echo -e "\E[33mCompleting..."
	echo ""
	sleep 5
	eval tput sgr0

	eval service apache2 restart
	eval service postgresql restart
	eval netdisco -p restart

	eval clear

	echo ""
	echo -e "\E[32mNetdisco Installation Complete"
	sleep 4
	eval tput sgr0
	echo ""
	echo -e "\E[36mOpen webbrowser and go to http://localhost/netdisco to verify installation and login."
	echo ""
	echo "Your login information:"
	echo ""
	echo "Username: admin"
	echo "Password: admin"
	eval tput sgr0
	echo ""
	echo ""
	echo "Netdisco Installer"
	echo "Adnan Tukic & Marcus Persson"
	echo ""
	sleep 3
	exit 1
else 
	echo "Quitting Installation..."
	sleep 3
	exit 1
fi
